// This file contains the explicit parts outside the Sequence class definition.
#include"sequence.h"
#include<string>
#include<iostream>
#include "partsum.h"
#include "globdef.h"

using namespace std;

    void Sequence::calcpartsum(double &strand, double &rcstrand, double &combstrand, double ** expbdg, double ** Partial_PS, double ** Partial_PSbow, double * extrapar)
    {
	strand = partsum(numstrand[0], seq.length(), expbdg, Partial_PS, Partial_PSbow, extrapar);
	rcstrand = partsum(numstrand[1], rcseq.length(), expbdg, Partial_PS, Partial_PSbow, extrapar);
	combstrand = partsum(numstrand[2], combseq.length(), expbdg, Partial_PS, Partial_PSbow, extrapar);
    }

void initseqs(Sequence* Seqlist)
{
    cout << "Allocating sequences... ";
    Sequence Templist[SEQLISTLENGTH] = { 	Sequence(1,"BHDDH",5.7,5.2,41.6,116),
    				Sequence(2,"DHHDU",4.9,5.1,45.8,132),
    				Sequence(3,"HHUHH",5.2,5.4,46.0,132),
    				Sequence(4,"BDDHDB",6.4,6.4,45.4,126),
    				Sequence(5,"DBBUDH",3.3,2.9,46.7,140),
    				Sequence(6,"DBDHHD",6.9,7.2,48.9,135),
    				Sequence(7,"DHBUUH",2.6,2.6,49.3,151),
    				Sequence(8,"DHHUHD",7.0,6.9,48.9,135),
    				Sequence(9,"DHUHDD",6.3,6.1,49.3,139),
    				Sequence(10,"HDBDDH",6.2,6.4,49.7,141),
    				Sequence(11,"HHDBDH",7.3,7.2,51.8,144),
    				Sequence(12,"BBUBDDH",4.7,5.3,54.1,160),
    				Sequence(13,"BDHUBUH",5.0,4.9,58.3,172),
    				Sequence(14,"BHDUUDB",4.7,4.9,55.6,164),
    				Sequence(15,"DBDHHDU",8.5,8.1,53.9,147),
    				Sequence(16,"DBUBDHU",4.3,4.2,53.2,158),
    				Sequence(17,"HHBDUUB",4.9,4.9,43.8,125),
    				Sequence(18,"UBBHUDD",5.4,5.0,46.2,132),
    				Sequence(19,"UHBBHDU",6.4,6.2,43.0,118),
    				Sequence(20,"BBBBBBBB",3.8,3.9,54.0,162),
    				Sequence(21,"BBHDHUBH",7.8,7.6,67.2,192),
    				Sequence(22,"BBUDDBHU",6.1,6.2,55.9,161),
    				Sequence(23,"BBUHUDHD",7.2,7.4,64.9,186),
    				Sequence(24,"BDDUBHUD",6.9,7.0,56.0,159),
    				Sequence(25,"BDHBDDUD",8.6,8.6,55.0,150),
    				Sequence(26,"BDUHHBUU",7.2,6.8,57.8,163),
    				Sequence(27,"BHDHUBBH",7.3,7.6,60.1,170),
    				Sequence(28,"BHUDDUHB",6.7,7.2,54.7,155),
    				Sequence(29,"DBBDBHDB",7.8,7.2,52.7,145),
    				Sequence(30,"DBDHHDUD",9.6,9.6,71.6,200),
    				Sequence(31,"DHDUHUBB",7.2,6.5,60.4,172),
    				Sequence(32,"DUBDHDUU",6.8,6.0,54.3,153),
    				Sequence(33,"DUBHUHHB",8.3,7.1,63.4,178),
    				Sequence(34,"DUDBDHHD",9.6,9.6,70.3,196),
    				Sequence(35,"DUHBHUDD",7.8,7.2,60.8,171),
    				Sequence(36,"DUUBDHDU",6.4,6.0,52.3,148),
    				Sequence(37,"HBDUBHHU",8.1,7.6,57.0,158),
    				Sequence(38,"HBHDDHUH",9.5,9.2,67.3,187),
    				Sequence(39,"HBHHUDHU",9.2,8.3,71.9,202),
    				Sequence(40,"HDDBHUUB",7.2,6.3,62.9,180),
    				Sequence(41,"HDDHUHBH",9.7,9.2,71.4,199),
    				Sequence(42,"HDHBDBUU",7.9,6.7,60.6,170),
    				Sequence(43,"UBBDUHHD",8.6,8.7,62.6,174),
    				Sequence(44,"UDDBDUBH",6.9,6.8,64.1,184),
    				Sequence(45,"UHDUHUUH",6.7,6.6,52.0,146),
    				Sequence(46,"UHUUDHBD",7.4,6.4,66.2,190),
    				Sequence(47,"UUBDBHDH",7.0,6.9,58.4,166),
    				Sequence(48,"UUHHDBDD",8.7,9.4,56.2,153),
    				Sequence(49,"BUBBDUHHD",8.7,9.6,60.7,168),
    				Sequence(50,"BUDUBUDDH",6.8,7.0,59.9,171),
    				Sequence(51,"DBBDBHDBB",8.7,8.2,63.3,177),
    				Sequence(52,"DBBDBHDBU",9.0,8.1,71.0,200),
    				Sequence(53,"DHDUHUUBD",8.2,7.8,71.5,205),
    				Sequence(54,"DHDUHUUBH",8.0,7.5,67.7,193),
    				Sequence(55,"DUBBDBHDH",9.0,8.6,70.8,199),
    				Sequence(56,"HDDBHUUBB",7.7,7.3,63.1,179),
    				Sequence(57,"HUBBDBHDH",9.1,8.8,77.5,221),
    				Sequence(58,"UUBBDUHHD",8.9,8.9,67.3,189),
    				Sequence(59,"BDHUBUUBUHD",9.1,9.3,95.4,279),
    				Sequence(60,"HDBUBBUBDHU",10.0,9.4,97.3,282),
    				Sequence(61,"BBUHHBUUBDBB",10.2,10.3,90.7,260),
    				Sequence(62,"BUUHHBUBDBBB",10.8,10.3,93.6,267),
    				Sequence(63,"HUDBHHBBUDUH",11.4,12.3,79.8,220),
    				Sequence(64,"UUHUBBUDDBUU",8.5,7.9, 76.9,221), // Results reported by Sugimoto et al (1995, Biochemistry)

				Sequence(1,"CCGG",3.52,3.49,30.6,87.4,0),
				Sequence(2,"CGCG",4.05,4.22,36.3,103.9,0),
				Sequence(3,"AGCCG",5.50,5.52,39.0,108.0,0),
				Sequence(4,"CACAG",3.62,3.66,33.7,97.0,0),
				Sequence(5,"ACCGCA",6.70,7.08,43.1,118.0,0),
				Sequence(6,"AGTTGC",5.69,5.40,37.0,100.9,0),
				Sequence(7,"ATGCGC",7.30,6.97,48.7,135.0,0),
				Sequence(8,"CCAACG",5.68,5.94,38.6,106.2,0),
				Sequence(9,"CCGCGG",7.97,7.90,41.4,107.8,0),
				Sequence(10,"CGCGCG",8.31,8.63,46.4,122.8,0),
				Sequence(11,"CGGACG",6.62,6.96,47.0,130.2,0),
				Sequence(12,"CGGCCG",8.31,7.90,38.7,98.0,0),
				Sequence(13,"CGGTGC",7.20,7.18,56.7,160.0,0),
				Sequence(14,"CGTACG",5.38,5.44,45.7,130.0,0),
				Sequence(15,"CGTGCC",6.90,7.18,46.3,127.0,0),
				Sequence(16,"CGTTGA",5.20,5.35,40.4,133.3,0),
				Sequence(17,"CGTTGC",6.24,6.34,40.4,110.2,0),
				Sequence(18,"CGTTGT",5.65,5.49,35.9,97.7,0),
				Sequence(19,"GCATGC",5.60,5.90,42.2,118.0,0),
				Sequence(20,"GCCGGC",8.51,7.97,45.2,118.3,0),
				Sequence(21,"GCCTGC",6.45,7.09,37.5,100.1,0),
				Sequence(22,"GCGAGC",7.67,7.27,51.4,141.0,0),
				Sequence(23,"GCGCGC",9.14,8.70,59.6,162.7,0),
				Sequence(24,"GGCGCC",7.93,7.97,43.5,114.7,0),
				Sequence(25,"GGGACC",6.49,6.30,32.7,84.5,0),
				Sequence(26,"GTGAAC",5.14,4.67,43.6,124.0,0),
				Sequence(27,"TGCGCA",6.90,7.09,42.5,115.0,0),
				Sequence(28,"TGTTGC",5.79,5.57,37.2,101.1,0),
				Sequence(29,"AATACCG",5.90,5.90,45.4,128.0,0),
				Sequence(30,"AGCCGTG",8.50,8.41,51.7,140.0,0),
				Sequence(31,"AGCTTCA",6.10,6.49,44.2,123.0,0),
				Sequence(32,"CAAAAAG",4.82,4.77,47.0,136.0,0),
				Sequence(33,"GGACTTA",5.60,5.43,50.7,146.0,0),
				Sequence(34,"AAAAAAAA",5.10,4.94,46.3,134.0,0),
				Sequence(35,"AAGCGTAG",8.00,7.98,55.4,153.0,0),
				Sequence(36,"AATCCAGT",6.80,7.13,52.4,146.0,0),
				Sequence(37,"ACATATGT",5.70,5.66,50.2,144.0,0),
				Sequence(38,"ACCTAGTC",6.50,7.15,65.6,191.0,0),
				Sequence(39,"ACGACCTC",8.70,8.76,59.8,165.0,0),
				Sequence(40,"AGAGAGAG",7.40,7.01,47.2,128.0,0),
				Sequence(41,"AGAGCTCT",7.76,7.50,49.8,135.6,0),
				Sequence(42,"AGCGTAAG",7.80,7.98,60.7,171.0,0),
				Sequence(43,"AGTCCTGA",7.50,7.83,54.6,152.0,0),
				Sequence(44,"ATGCGCAT",9.00,8.85,62.0,171.0,0),
				Sequence(45,"CAAAAAAG",5.65,5.77,59.0,172.0,0),
				Sequence(46,"CAAGCTTG",6.98,7.34,54.2,152.3,0),
				Sequence(47,"CACGGCTC",10.00,9.76,64.7,177.0,0),
				Sequence(48,"CATCGATG",7.59,7.07,59.2,166.3,0),
				Sequence(49,"CCATATGG",6.80,6.56,6.1,192.0,0),
				Sequence(50,"CGATATCG",7.30,6.92,62.7,179.0,0),
				Sequence(51,"CGATATCG",6.88,6.92,53.7,151.1,0),
				Sequence(52,"CGCGTATA",8.40,8.05,58.8,163.0,0),
				Sequence(53,"CGCTGTAA",7.90,8.15,60.3,169.0,0),
				Sequence(54,"CGTCGACG",9.79,9.63,64.1,175.1,0),
				Sequence(55,"CGTCGTCC",9.67,9.70,60.9,165.2,0),
				Sequence(56,"CTAGTGGA",7.50,7.16,61.4,174.0,0),
				Sequence(57,"CTCACGGC",9.80,9.76,67.7,187.0,0),
				Sequence(58,"CTGAGTCC",8.00,7.93,60.3,169.0,0),
				Sequence(59,"GAAGCTTC",6.70,7.04,57.4,163.0,0),
				Sequence(60,"CAATATTC",4.30,4.58,57.7,172.0,0),
				Sequence(61,"GACTAGTC",6.60,6.26,55.6,158.0,0),
				Sequence(62,"GAGTACTC",5.80,6.26,57.6,168.0,0),
				Sequence(63,"GATTAATC",4.30,4.58,57.5,172.0,0),
				Sequence(64,"GATGCATC",7.34,7.14,56.1,157.3,0),
				Sequence(65,"GCATATGC",7.80,7.36,55.8,155.0,0),
				Sequence(66,"GCCAGTTA",8.20,7.82,58.9,164.0,0),
				Sequence(67,"GGAATTCC",7.40,6.80,58.3,164.0,0),
				Sequence(68,"GGACCTCG",9.03,9.21,57.7,156.9,0),
				Sequence(69,"GGACGTCC",8.99,8.97,60.0,164.5,0),
				Sequence(70,"GGAGCACG",9.66,9.76,61.6,167.4,0),
				Sequence(71,"GGAGCTCC",8.70,8.72,56.8,155.0,0),
				Sequence(72,"GGTATACC",5.50,6.24,54.5,158.0,0),
				Sequence(73,"GGTGCCAA",9.00,9.25,65.6,183.0,0),
				Sequence(74,"GTACGTAC",7.05,6.73,53.8,150.9,0),
				Sequence(75,"GTAGCTAC",6.99,6.48,53.3,149.2,0),
				Sequence(76,"GTCGAACA",8.30,8.09,62.6,175.0,0),
				Sequence(77,"GTCTAGAC",6.50,6.26,57.4,164.0,0),
				Sequence(78,"TAGATCTA",5.10,4.74,49.2,142.2,0),
				Sequence(79,"TAGGCCTA",8.20,7.18,54.7,150.0,0),
				Sequence(80,"TATGCATA",5.90,5.60,48.6,138.0,0),
				Sequence(81,"TCTATAGA",4.33,4.74,45.7,133.4,0),
				Sequence(82,"TGAGCTCA",7.73,7.84,50.5,137.9,0),
				Sequence(83,"AAAAAAAAA",6.20,5.94,59.8,173.0,0),
				Sequence(84,"ATAACTGGC",9.00,8.70,60.3,166.0,0),
				Sequence(85,"ATCTATCCG",8.70,8.22,66.9,188.0,0),
				Sequence(86,"CAAAAAAAG",7.21,6.77,68.0,196.0,0),
				Sequence(87,"CAAACAAAG",7.74,7.66,64.5,183.0,0),
				Sequence(88,"CAAAGAAAG",7.28,7.35,62.8,179.0,0),
				Sequence(89,"CAAATAAAG",6.49,6.23,58.6,168.0,0),
				Sequence(90,"CGCTGTTAC",9.90,9.64,76.7,216.0,0),
				Sequence(91,"GCCAGTTAA",8.80,8.82,67.5,189.0,0),
				Sequence(92,"AAAAAAAAAA",6.70,6.94,78.3,231.0,0),
				Sequence(93,"ATGAGCTCAT",10.00,9.60,68.0,187.0,0),
				Sequence(94,"CGGCAAGCGC",13.30,14.67,85.6,233.0,0),
				Sequence(95,"GCGAAAAGCG",11.86,12.44,74.1,201.0,0),
				Sequence(96,"GCGAATTCGC",12.91,11.94,80.0,216.3,0),
				Sequence(97,"TAGGTTATAA",7.00,7.12,65.1,188.0,0),
				Sequence(98,"ACGTATTATGC",10.40,10.65,78.9,221.0,0),
				Sequence(99,"CCATCGCTACC",13.30,13.06,84.8,230.7,0),
				Sequence(100,"CCATTGCTACC",12.17,12.04,82.5,226.8,0),
				Sequence(101,"ATTGGATACAAA",10.30,10.76,76.2,213.0,0),
				Sequence(102,"CAACCAACCAAC",13.75,13.39,104.0,291.0,0),
				Sequence(103,"CGCGAATTCGCG",16.52,16.28,102.8,278.2,0),
				Sequence(104,"CTTCCTTCCTTC",13.20,12.46,89.5,246.0,0),
				Sequence(105,"GAACAAGATGC",12.85,13.22,93.7,260.8,0),
				Sequence(106,"GGAACTTGATGC",12.85,13.22,92.5,256.7,0),
				Sequence(107,"ACATTATTATTACA",11.30,11.10,89.9,254.0,0),
				Sequence(108,"CAACTTGATATTAATA",12.37,13.29,102.0,289.0,0), // Supplementary data to: "G.T mismatches by Allawi and SantaLucia (1997, Biochemistry)"
   
				Sequence(1,"DDHH",4.55,0,4.36,34.21,95.6,0),
				Sequence(2,"DHDH",3.66,0,3.62,33.31,95.6,0),
				Sequence(3,"HDHD",4.61,0,4.68,30.48,83.4,0),
				Sequence(4,"HHDD",5.37,0,5.42,35.79,98.1,0),
				Sequence(5,"BDHDB",4.97,0,5.14,45.40,130.4,0),
				Sequence(6,"BHDHB",5.05,0,5.22,46.31,133.0,0),
				Sequence(7,"DBDBH",4.70,0,4.45,40.20,115.4,0),
				Sequence(8,"HDBDH",6.17,0,6.04,45.31,126.2,0),
				Sequence(9,"HDUDH",6.14,0,6.12,43.38,120.1,0),
				Sequence(10,"BDDHHU",8.51,0,7.94,59.78,164.5,0),
				Sequence(11,"BHDHDU",7.99,0,7.94,50.07,135.7,0),
				Sequence(12,"BHHDDU",8.36,0,8.68,48.19,128.4,0),
				Sequence(13,"DBDHUH",6.59,0,6.54,50.31,141.0,0),
				Sequence(14,"DBHDUH",6.68,0,7.28,51.55,144.7,0),
				Sequence(15,"DDBUHH",7.30,0,7.32,56.93,159.9,0),
				Sequence(16,"DDHDHH",9.84,0,10.14,60.79,164.3,0),
				Sequence(17,"DDUBHH",7.80,0,7.49,54.10,149.1,0),
				Sequence(18,"DHDHDH",9.12,0,9.40,54.51,146.4,0),
				Sequence(19,"DHHDDH",9.90,0,10.14,54.12,142.6,0),
				Sequence(20,"DUHDBH",7.11,0,7.28,55.41,155.7,0),
				Sequence(21,"HBDHUD",7.35,0,7.02,58.06,163.5,0),
				Sequence(22,"HBHBHB",6.95,0,6.67,62.05,178.1,0),
				Sequence(23,"HBHDUD",7.98,0,7.76,62.30,175.3,0),
				Sequence(24,"HBHHBH",8.50,0,8.03,55.70,152.2,0),
				Sequence(25,"HDBBDH",7.01,0,6.97,50.57,140.5,0),
				Sequence(26,"HDBUDH",7.26,0,7.25,51.89,143.9,0),
				Sequence(27,"HDBUHD",7.38,0,7.64,62.34,177.2,0),
				Sequence(28,"HDDHDH",10.88,0,10.73,59.69,157.4,0),
				Sequence(29,"HDDHHD",11.20,0,11.20,62.72,166.0,0),
				Sequence(30,"HDHDDH",10.91,0,10.73,57.85,151.3,0),
				Sequence(31,"HDHDHD",10.62,0,10.46,65.98,178.5,0),
				Sequence(32,"HDHDHH",11.38,0,10.73,71.16,192.7,0),
				Sequence(33,"HDHHDH",10.40,0,10.73,58.50,155.0,0),
				Sequence(34,"HDHUDH",8.76,0,8.64,52.38,140.6,0),
				Sequence(35,"HDUBDH",7.56,0,7.34,58.02,162.7,0),
				Sequence(36,"HDUBHD",7.92,0,7.81,59.13,165.1,0),
				Sequence(37,"HHBUDD",7.44,0,7.80,53.70,149.1,0),
				Sequence(38,"HHDHDD",11.33,0,11.20,67.78,182.0,0),
				Sequence(39,"HHDHDH",10.78,0,10.73,63.53,170.1,0),
				Sequence(40,"HHUBDD",7.35,0,7.81,54.90,153.4,0),
				Sequence(41,"HUDHBD",7.09,0,7.02,53.63,150.1,0),
				Sequence(42,"HUHDBD",7.65,0,7.60,59.61,167.5,0),
				Sequence(43,"HUHHUH",7.67,0,7.87,48.84,132.7,0),
				Sequence(44,"HUHUDH",7.18,0,7.21,50.88,140.9,0),
				Sequence(45,"UDBUHB",4.31,0,4.60,41.89,121.2,0),
				Sequence(46,"UDDHHB",7.79,0,8.16,51.92,142.3,0),
				Sequence(47,"UDHDHB",6.85,0,7.42,48.94,135.7,0),
				Sequence(48,"UDUBHB",4.95,0,4.77,36.53,101.8,0),
				Sequence(49,"UHBUDB",5.05,0,4.60,44.73,128.0,0),
				Sequence(50,"UHDHDB",8.22,0,8.00,51.54,139.7,0),
				Sequence(51,"BBHHBHH",9.54,0,9.42,58.72,158.6,0),
				Sequence(52,"BDUHUDB",7.92,0,8.14,52.24,142.9,0),
				Sequence(53,"BHUDUHB",7.52,0,8.22,51.48,141.8,0),
				Sequence(54,"HBDUDBH",9.05,0,9.12,64.11,177.5,0),
				Sequence(55,"HBHUHBH",9.71,0,9.12,70.49,196.0,0),
				Sequence(56,"HUDBDUH",8.62,0,9.04,57.81,158.6,0),
				Sequence(57,"BBDUBHUU",7.16,0,6.41,54.62,153.0,0),
				Sequence(58,"BBUHDBUU",7.18,0,6.28,59.81,169.7,0),
				Sequence(59,"BDDUUUHD",10.64,0,10.43,77.42,215.3,0),
				Sequence(60,"BDUBUBHU",6.98,0,6.98,59.21,168.4,0),
				Sequence(61,"BDUUBBHU",6.16,0,6.41,47.23,132.4,0),
				Sequence(62,"BHBHBHBH",11.12,0,10.83,73.66,201.7,0),
				Sequence(63,"BHBUBUDU",6.58,0,6.97,64.51,186.8,0),
				Sequence(64,"BHUUBBDU",6.36,0,6.41,52.42,148.5,0),
				Sequence(65,"BUBDHUBU",6.53,0,6.28,54.36,154.2,0),
				Sequence(66,"BUDUBHBU",7.20,0,6.97,59.89,169.9,0),
				Sequence(67,"BUHDHDBU",10.17,0,10.20,64.39,174.8,0),
				Sequence(68,"BUHUBDBU",6.49,0,6.81,55.91,159.3,0),
				Sequence(69,"DBBBBBBH",4.61,0,4.75,53.83,158.7,0),
				Sequence(70,"DBUHDBUH",9.67,0,9.54,73.67,206.3,0),
				Sequence(71,"DHBDHDBH",12.32,0,12.83,70.45,187.4,0),
				Sequence(72,"DUDHDBDB",12.11,0,12.13,72.61,195.1,0),
				Sequence(73,"HBBDHUUD",9.30,0,8.88,77.00,218.3,0),
				Sequence(74,"HBUBUBUD",6.09,0,6.14,62.04,180.4,0),
				Sequence(75,"HBUHDBUD",10.12,0,10.02,72.75,201.9,0),
				Sequence(76,"HHDUUDBB",10.20,0,10.54,61.59,165.7,0),
				Sequence(77,"HUBUBUBD",5.94,0,6.15,63.35,185.1,0),
				Sequence(78,"HUDUBHBD",10.11,0,10.15,76.02,212.5,0),
				Sequence(79,"HUUDHBBD",8.76,0,8.88,74.19,211.0,0),
				Sequence(80,"UBHBUDUB",7.25,0,7.20,60.15,170.6,0),
				Sequence(81,"UBUHDBUB",7.27,0,7.08,67.73,195.0,0),
				Sequence(82,"UDDUUHDB",11.09,0,11.27,70.27,190.8,0),
				Sequence(83,"UDUBUBHB",6.96,0,7.20,62.06,177.7,0),
				Sequence(84,"UHBDDUDB",12.34,0,11.51,76.09,205.6,0),
				Sequence(85,"UUDDHHBB",10.79,0,10.02,67.43,182.6,0),
				Sequence(86,"UUHDHDBB",10.18,0,9.86,62.17,167.6,0),
				Sequence(87,"UUHHDDBB",11.00,0,10.60,63.68,169.8,0),
				Sequence(88,"UUHUBDBB",6.70,0,6.47,49.45,137.8,0),
				Sequence(89,"DBBBBBBBH",5.47,0,5.68,59.78,175.1,0),
				Sequence(90,"BBHHUUHHBB",12.69,0,13.10,75.84,203.6,0) // These 90 were used in regression analysis by Xia et al., Biochemistry (1998)
    };
   
    for(int i=0; i<SEQLISTLENGTH; i++)
    {
	Seqlist[i] = Templist[i];
	Seqlist[i].remake(); // Because the copy constructor doesn't work here.
    }
    cout << "Sequences allocated... \n";
} // end initseqs() function

